unit generico;

{$mode objfpc}
{$INTERFACES CORBA}

interface
uses sysutils,eccezioni;

type generic tipoDato<Tipo>=record
	cella:Tipo;
end;

type generic ElementoLista<_T> = Interface
	Function GetItem(AIndex : qword) : _T;
	Procedure SetItem(AIndex : qword; AValue : _T);
	Function GetCount : qword;
	procedure addItem(AValue : _T);
        procedure Clear;
	function lunghezza:integer;
	Property Items [AIndex : qword] : _T Read GetItem Write SetItem;
	Property Count : qword Read GetCount;
end;

type generic Lista<Tipo>=class (TObject, specialize ElementoLista<Tipo>)
private
	elementi:array of Tipo;
	caricati:qword;
	Function GetItem(AIndex : qword) : Tipo;
	Procedure SetItem(AIndex : qword; AValue : Tipo);
	Function GetCount : qword;
	procedure raddoppiaMemoria;
public
	constructor crea();
	constructor crea(dimensione:qword);
	constructor crea(dimensione:qword; zero:Tipo);
	procedure addItem(AValue : Tipo);
        procedure Clear;
	function lunghezza:integer;
	Property Items [AIndex : qword] : Tipo Read GetItem Write SetItem;
	Property Count : qword Read GetCount;
end;
 

implementation

constructor Lista.crea();
begin
	setLength(elementi, 10);
	caricati:=0;
end;

constructor Lista.crea(dimensione:qword);
begin
	if dimensione < 5 then dimensione:=5;
	if dimensione > 300000 then dimensione:=300000;
	setLength(elementi, dimensione);
	caricati:=0;
end;

constructor Lista.crea(dimensione:qword; zero:Tipo);
var i:integer;
begin
	if dimensione < 5 then dimensione:=5;
	if dimensione > 300000 then dimensione:=300000;
	setLength(elementi, dimensione);
	i:=0;
	caricati:=dimensione;
	while i < caricati do
	begin
		elementi[i]:=zero;
		i:=i + 1;
	end;
end;

Function Lista.GetItem(AIndex : qword) : Tipo;
var esito:Tipo;
begin
	if AIndex < caricati then
	begin
		esito:=elementi[AIndex];
	end
	else
		raise FuoriRange.crea(Format('Impossibile accedere alla cella %d', [AIndex]));
	GetItem:=esito;
end;

procedure Lista.addItem(AValue : Tipo);
begin
	if caricati >= length(elementi) then
		raddoppiaMemoria;
	elementi[caricati]:=AValue;
	caricati:=caricati + 1;
end;

procedure Lista.Clear;
begin
     caricati:=0;
end;

Procedure Lista.SetItem(AIndex : qword; AValue : Tipo);
begin
	if AIndex >= caricati then
	begin
		raise FuoriRange.crea(Format('Impossibile accedere alla cella %d', [AIndex]));
	end;
	elementi[AIndex]:=AValue;
end;

Function Lista.GetCount : qword;
begin
	GetCount:=caricati;
end;

function Lista.lunghezza:integer;
begin
	lunghezza:=length(elementi);
end;

procedure Lista.raddoppiaMemoria;
var nuova:integer;
begin
	nuova:=length(elementi) * 2;
	if (nuova > 30000000) or (nuova < 1) then
	begin
		raise FuoriRange.crea('Impossibile allocare più di 3000''000 elementi.');
	end;
	setLength(elementi, nuova);
end;

begin
 // non fa nulla
end.
