unit gestore_del_form;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, FileUtil, Forms, Controls, Graphics, Dialogs, StdCtrls,
  lima, generico, eccezioni;


type VettoreStringhe = specialize Lista<string>; // tipo elementi stringa

type

  { TForm1 }

  TForm1 = class(TForm)
    ButtonCancella: TButton;
    ButtonGenera: TButton;
    EditFiltroParole: TEdit;
    EditQuanteParole: TEdit;
    GroupBoxSelezionaParola: TGroupBox;
    GroupBoxLingua: TGroupBox;
    Label1: TLabel;
    LabelSpiegazioneFiltro: TLabel;
    MemoRusultato: TMemo;
    RadioButtonFiltro: TRadioButton;
    RadioButtonParoleCasuali: TRadioButton;
    RadioButtonInglese: TRadioButton;
    RadioButtonItaliano: TRadioButton;
    procedure ButtonCancellaClick(Sender: TObject);
    procedure ButtonGeneraClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure RadioButtonParoleCasualiChange(Sender: TObject);
  private
    { private declarations }
    var elencoItaliano, elencoInglese:VettoreStringhe;
    procedure cancella;
  public
    { public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.lfm}

function test(parola, filtro:string):boolean;
var esito:boolean;
    i, fine:integer;
begin
  if filtro='' then
    esito:=true
  else
  begin
      esito:=length(parola) = length(filtro);
      i:=1;
      fine:=length(parola);
      while (i <= fine) and (esito) do
      begin
        esito:=(upCase(parola[i]) = upCase(filtro[i])) or (filtro[i] = '#');
        i:=i + 1;
      end;
  end;
  test:=esito;
end;

{ TForm1 }

procedure TForm1.FormCreate(Sender: TObject);
var fLogicoItaliano, fLogicoInglese:tlima;
    aperturaItaliano, aperturaInglese:boolean;
begin
  Form1.Text:='Parole';
  cancella;
  LabelSpiegazioneFiltro.Caption:='Filtro: digitare'+ #13 + #10 + '# per lettere jolli';
  MemoRusultato.ReadOnly:=true;
  aperturaItaliano:=fLogicoItaliano.ApriFile('italiano.txt', 'r');
  aperturaInglese:=fLogicoInglese.ApriFile('inglese.txt', 'r');
  if not (aperturaItaliano and aperturaInglese) then
  begin
     if not aperturaItaliano then
        ShowMessage('File italiano.txt non trovato ! ');
     if not aperturaInglese then
        ShowMessage('File inglese.txt non trovato ! ');
     Application.Terminate;
  end;
  elencoItaliano:=VettoreStringhe.crea(10);
  elencoInglese:=VettoreStringhe.crea(10);
  while (not fLogicoItaliano.fine) do
  begin
    elencoItaliano.addItem(fLogicoItaliano.leggi);
  end;
  while (not fLogicoInglese.fine) do
  begin
    elencoInglese.addItem(fLogicoInglese.leggi);
  end;
  fLogicoItaliano.ChiudiFile;
  fLogicoInglese.ChiudiFile;
  Randomize;
end;

procedure TForm1.RadioButtonParoleCasualiChange(Sender: TObject);
begin
  if RadioButtonParoleCasuali.Checked then
  begin
     EditFiltroParole.Color:=$808080;
     EditFiltroParole.ReadOnly:=true;
  end
  else
  begin
    EditFiltroParole.Color:=clWhite;
    EditFiltroParole.ReadOnly:=false;
  end;
end;

procedure TForm1.ButtonCancellaClick(Sender: TObject);
begin
  cancella;
  EditQuanteParole.SetFocus;
end;

procedure TForm1.ButtonGeneraClick(Sender: TObject);
var filtro:string;
    numeroParole,conto:integer;
    estratto:qword;
    tempoImpiegato:TdateTime;
begin
  conto:=0;
  numeroParole:=StrToIntDef(EditQuanteParole.text, -1);
  MemoRusultato.Lines.Clear;
  if (numeroParole < 2) or (numeroParole > 40) then
  begin
     ShowMessage('Si possono generare fino a 40 parole.');
     numeroParole:=-1;
     cancella;
  end;
  if RadioButtonParoleCasuali.Checked then
      begin
         filtro:='';
      end
      else
      begin
        filtro:=EditFiltroParole.Text;
      end;
  if RadioButtonItaliano.Checked  then
  begin
    tempoImpiegato:=now;
    while (conto < numeroParole) and ((now - tempoImpiegato) < 6e-5) do
    begin
       estratto:=random(integer(elencoItaliano.Count));
       if test(elencoItaliano.Items[estratto], filtro) then
       begin
           MemoRusultato.Lines.Add(elencoItaliano.Items[estratto]);
           conto:=conto + 1;
       end;
    end;
  end
  else
  begin
    tempoImpiegato:=now;
    while (conto < numeroParole) and ((now - tempoImpiegato) < 6e-5) do
    begin
       estratto:=random(integer(elencoInglese.Count));
       if test(elencoInglese.Items[estratto], filtro) then
       begin
           MemoRusultato.Lines.Add(elencoInglese.Items[estratto]);
           conto:=conto + 1;
       end;
    end;
  end;
end;

procedure TForm1.cancella;
begin
   EditQuanteParole.Text:='';
   RadioButtonItaliano.Checked:=true;
   RadioButtonParoleCasuali.Checked:=true;
   MemoRusultato.Lines.Clear;
   EditFiltroParole.Text:='';
end;

end.

